utility rtmUtilityExport "RTM utility export"
(
	local tA=#()
	local TMCenter=false
	local rtmTM=[0,0,0]
	local assignAsCenterCaption="Assign as center for TM"
	local saveRTMCaption=#("@ ( keys >= 3 )","Make rtm")
	local selectionsPresence=false

	group "Body parts (selections)"
	(
		Label uSCountLabel "" across:2
		Button uFindSelections "Find" width:70
		ListBox uSelectionsList items:#() height:25
		Button uRemoveSelected "Remove from list" width:134
		Button uAssignAsCenter "" width:134
	)
	on uRemoveSelected pressed do
	(
		if(uSelectionsList.items.count>0)and(uSelectionsList.selection>0)do
		uSelectionsList.items=deleteItem uSelectionsList.items uSelectionsList.selection
		uSCountLabel.text=tA.count as string
		if tA.count>0 then uRemoveSelected.enabled=true else uRemoveSelected.enabled=false
		if(TMCenter!=false)do
		(
			if (findItem tA TMCenter)==0 do
			(
				messageBox (TMCenter+" not found in tA!")
				TMCenter=false
				uAssignAsCenter.caption=assignAsCenterCaption
			)
		)
	)
	on uFindSelections pressed do
	(
		tA=#()
		local names_array=for i in $* collect i.name
		local ss
		for i=1 to names_array.count do
		(
			ss=names_array[i]
			tA[i]=ss
		)
		if tA.count<1 then selectionsPresence=false else selectionsPresence=true
		uSelectionsList.items=tA
		uSCountLabel.text=tA.count as string
		if tA.count>0 do uRemoveSelected.enabled=true
	)
	timer clockCTM interval:500 active:false
	on uSelectionsList doubleClicked sel do
	(
		clockCTM.active=false
		clockCTM.ticks=1
		execute ("select $"+tA[sel])
		uAssignAsCenter.enabled=true
		clockCTM.active=true
	)
	on clockCTM tick do
	(
		if clockCTM.ticks>4 do
		(
			clockCTM.active=false
			clockCTM.ticks=1
			uAssignAsCenter.enabled=false
		)
	)
	on uAssignAsCenter pressed do
	(
		TMCenter=tA[uSelectionsList.selection]
		uAssignAsCenter.caption="Center: "+TMCenter
		uAssignAsCenter.enabled=false
	)
	group "Total move"
	(
		label uX "x          " across:3
		label uY "y          "
		label uZ "z          "
		spinner uTM_x "" range:[-100,100,0] fieldWidth:36 across:3
		spinner uTM_y "" range:[-100,100,0] fieldWidth:36
		spinner uTM_z "" range:[-100,100,0] fieldWidth:36
	)
	group "Keys"
	(
		ListBox uOutKeyTimesList items:#() height:10
		button uAddKeyTime "Add" width:42 height:20 across:3
		button uInsKeyTime "Ins" width:42 height:20
		button uDelKeyTime "Del" width:42 height:20
	)
	button uSaveRTM "Save to file please" width:140 height:20

	local keyTimes=#()
	local keyTimes2=#()
	local keyTimesInRTM=#()
	function recalc c =
	(
		keyTimesInRTM[c]=1.0
		keyTimesInRTM[1]=0.0
		keyTimes2[c]=keyTimes[c]+"          (1.0)"
		keyTimes2[1]=keyTimes[1]+"          (0.0)"
		if c>2 then
		(
			local start=keyTimes[1] as float
			local end=keyTimes[c] as float
			local procent=100 / (end-start)
			for i=2 to (c-1) do
			(
				local pos=(keyTimes[i] as float)-start
				keyTimesInRTM[i]=pos*procent/100
				keyTimes2[i]=keyTimes[i]+"          ("+(keyTimesInRTM[i] as string)+")"
			)
			uSaveRTM.enabled=true
			uSaveRTM.caption=saveRTMCaption[2]
			if (TMCenter!=false) do
			(
				local x,y,z,x1,y1,z1
				at time (keyTimes[1] as float)
				(
					x=execute ("$"+TMCenter+".transform[4][1]") as float
					y=execute ("$"+TMCenter+".transform[4][2]") as float
					z=execute ("$"+TMCenter+".transform[4][3]") as float
				)
				at time (keyTimes[c] as float)
				(
					x1=execute ("$"+TMCenter+".transform[4][1]") as float
					y1=execute ("$"+TMCenter+".transform[4][2]") as float
					z1=execute ("$"+TMCenter+".transform[4][3]") as float
				)
				rtmTM[1]=x1-x
				rtmTM[2]=y1-y
				uTM_x.value=rtmTM[1]
				uTM_y.value=rtmTM[2]
				uTM_z.value=rtmTM[3]
			)
		)
		else
		(
			uSaveRTM.enabled=false
			uSaveRTM.caption=saveRTMCaption[1]
		)
	)
	on uTM_x changed uTM_x_var do rtmTM[1]=uTM_x_var
	on uTM_y changed uTM_y_var do rtmTM[2]=uTM_y_var
	on uTM_z changed uTM_z_var do rtmTM[3]=uTM_z_var
	
	on uAddKeyTime pressed do
	(
		local slTime=sliderTime.frame as string
		if (keyTimes.count<1) or (slTime as float)>(keyTimes[keyTimes.count] as float)  then (
			keyTimes=append keyTimes slTime
			keyTimes2=append keyTimes2 keyTimes[1]
			recalc(keyTimes.count)
			uOutKeyTimesList.items=keyTimes2
		)else(
			messagebox "Check Keys listbox please\n"
		)
	)
	on uInsKeyTime pressed do
	(
		local slTime=sliderTime.frame as string
		local mode="alert"
		if keyTimes.count>1 then (
			local sel=uOutKeyTimesList.selection
			if (slTime as float)>(keyTimes[sel] as float) then (
				if (keyTimes[sel+1]!=undefined) then (
					if (slTime as float)<(keyTimes[sel+1] as float) then (
						mode="insert"
					)else(mode="alert")
				)else(mode="append")
			)else(mode="alert")
		) else if (slTime as float)>(keyTimes[keyTimes.count] as float) do mode="append"
		if mode=="append" then (
			keyTimes=append keyTimes slTime
			keyTimes2=append keyTimes2 slTime
			recalc(keyTimes.count)
			uOutKeyTimesList.items=keyTimes2
		)else if mode=="insert" then (
			insertItem slTime keyTimes (sel+1)
			insertItem slTime keyTimes2 (sel+1)
			recalc(keyTimes.count)
			uOutKeyTimesList.items=keyTimes2
		)else if mode=="alert" do (
			messagebox "Check Keys listbox please\n"
		)
	)
	on uDelKeyTime pressed do
	(
		if keyTimes.count>0 then (
			deleteItem keyTimes uOutKeyTimesList.selection
			deleteItem keyTimes2 uOutKeyTimesList.selection
			if keyTimes.count>1 then ( 
				recalc(keyTimes.count)
			)
			uOutKeyTimesList.items=keyTimes2
		)
	)
	on uOutKeyTimesList doubleClicked sel do
	(
		sliderTime=(keyTimes[sel] as float) as time
	)

	local all2=#()
	local M2=#(1,-1,1,-1,1,-1,1,-1,1,-1,1,-1)

	on uSaveRTM pressed do
	(
		all2=#()
		for frn=1 to keyTimes.count do
		(
			all2[frn]=#()
			at time (keyTimes[frn] as float)
			(
				for i=1 to tA.count do
				(
					all2[frn][i]=#()
					all2[frn][i][1]=tA[i]
					st=execute ("$"+all2[frn][i][1]+".transform")

					all2[frn][i]=#(all2[frn][i][1], st[1][1]*M2[1], st[1][3]*M2[2], st[1][2]*M2[3], st[3][1]*M2[4], st[3][3]*M2[5], st[3][2]*M2[6], st[2][1]*M2[7], st[2][3]*M2[8], st[2][2]*M2[9], \ 
					st[4][1]*M2[10], \ 
					st[4][3]*M2[11], \ 
					(st[4][2]*M2[12]+(rtmTM[2])*keyTimesInRTM[frn] ))
				)
			)
		)
		
		fileSaveName=getSaveFileName caption:"Save to" filename:"*.rtm" types:"OFP animation (*.rtm)"
		if (fileSaveName != undefined) and (selectionsPresence) do
		(
			if (getFilenameType fileSaveName)!=".rtm" do
				fileSaveName=(getFilenamePath fileSaveName)+(getFilenameFile fileSaveName)+".rtm"
			F2=fopen fileSaveName "wb"
			if F2!=undefined do
			(
				local startPos=28
				WriteString F2 "RTM_0101"
				fseek F2 8 #seek_set
				WriteFloat F2 rtmTM[1]
				WriteFloat F2 rtmTM[3]

				WriteFloat F2 -rtmTM[2]
				WriteLong F2 keyTimes.count
				WriteLong F2 tA.count
				fseek F2 startPos #seek_set
				for i=1 to tA.count do
				(
					WriteString F2 tA[i]
					startPos=startPos+32
					fseek F2 startPos #seek_set
				)
				
				for frn=1 to keyTimes.count do
				(
					WriteFloat F2 keyTimesInRTM[frn]
					for i=1 to tA.count do
					(
						startPos=ftell F2
						WriteString F2 all2[frn][i][1]
						local matrix_start=startPos+32
						fseek F2 matrix_start #seek_set
						for j=2 to 13 by 3 do
						(
							WriteFloat F2 all2[frn][i][j]
							WriteFloat F2 all2[frn][i][j+1]
							WriteFloat F2 all2[frn][i][j+2]
						)
					)
				)
				fclose F2
			)
		)
		if (not selectionsPresence) do messagebox "Nothing saved!\n\nWhere are selections?"
	)

	on rtmUtilityExport open do
	(
		uAssignAsCenter.caption=assignAsCenterCaption
		uRemoveSelected.enabled=false
		uAssignAsCenter.enabled=false
		uSaveRTM.enabled=false
		uSaveRTM.caption=saveRTMCaption[1]

		tA=#()
		local names_array=for i in $* collect i.name
		for i=1 to names_array.count do
		(
			local ss=names_array[i]
			tA[i]=ss
		)
		if tA.count<1 then selectionsPresence=false else selectionsPresence=true
		uSelectionsList.items=tA
		uSCountLabel.text=tA.count as string
		if tA.count>0 do uRemoveSelected.enabled=true

	)
	on rtmUtilityExport close do
	(
		tA=#()
		rtmTM=[0,0,0]
		keyTimes=#()
		keyTimes2=#()
		keyTimesInRTM=#()
		all2=#()
		M2=#()
		uSelectionsList.items=#()
		uOutKeyTimesList.items=#()
	)
)