utility rtmUtilityImport "RTM utility import"
(
	local all = #()
	local all2 = #()
	local fromTimeVar = 0
	local M = #(1, 1, -1, 1, 1, -1, -1, -1, 1, -1, -1, 1)
	local M2 = #(1, -1, 1, -1, 1, -1, 1, -1, 1, -1, 1, -1)
	local rtmTM = [0,0,0]
	local rtmFrames
	local startPos = 28
	local rtmComponentCount = 0




	button uOpenRTM "File..." width:154 height:20

	group "Selections in file"
	(
		ListBox uSelectionsList items:#() height:25
		Label uSelectionsInFile "" across:2
		Label uFramesInFile ""
	)

	group "Total move"
	(
		spinner uTM_x "X: " range:[-100,100,0] fieldWidth:110
		spinner uTM_y "Y: " range:[-100,100,0] fieldWidth:110
		spinner uTM_z "Z: " range:[-100,100,0] fieldWidth:110
		checkbox u_applyTMbox "apply total move" checked:true
	)
	on uTM_x changed uTMxArg do (rtmTM[1] = uTMxArg)
	on uTM_y changed uTMyArg do (rtmTM[3] = - uTMyArg)
	on uTM_z changed uTMzArg do (rtmTM[2] = uTMzArg)
	on u_applyTMbox changed uApplyTMboxArg do
	(
		if uApplyTMboxArg == false then (rtmTM[1] = 0; rtmTM[2] = 0; rtmTM[3] = 0)
		else (rtmTM[1] = uTM_x.value; rtmTM[3] = - uTM_y.value; rtmTM[2] = uTM_z.value)
	)

	group "Apply RTM to scene"
	(
		button uApplyRTM "Make keys" width:80 height:20
	)	
	

	group "Key times"
	(
		ListBox uKeyTimesList items:#() height:12
	)


	local keyTimes = #()
	local keyTimes2 = #()
	local keyTimesInRTM = #()
	local componentNames = #()
	local rtmSignature
	local rtmKeyTimes = #()
	

	on uOpenRTM pressed do
	(
		fileOpenName = getOpenFileName caption:"Open RTM file" filename:"*.rtm" types:"OFP animation (*.rtm)"
		if fileOpenName != undefined do
		(
			uSelectionsList.items = #()
			uKeyTimesList.items = #()
			startPos = 28
	
			F = fopen fileOpenName "rb"
			if F != undefined do
			(

				rtmSignature = ReadLong F
				if rtmSignature != 1598903378 do messagebox "Bad file type\nor unsupported version!"
				rtmVersion = ReadLong F
				if rtmVersion != 825241904 do messagebox "Bad version!"

				rtmTM[1] = ReadFloat F
				rtmTM[2] = ReadFloat F
				rtmTM[3] = ReadFloat F
				rtmFrames = ReadLong F
				rtmComponentCount = ReadLong F
				fseek F startPos #seek_set
				for i = 1 to rtmComponentCount do
				(
					componentNames[i] = ReadString F
					startPos = startPos + 32
					fseek F startPos #seek_set
				)
				
				for frame_n = 1 to rtmFrames do
				(
					all[frame_n] = #()
					rtmKeyTimes[frame_n] = ReadFloat F

					for i = 1 to rtmComponentCount do
					(
						startPos = ftell F
						component = ReadString F
						all[frame_n][i] = #()
						
						local matrix_start = startPos + 32
						fseek F matrix_start #seek_set
						all[frame_n][i][1] = component
						for j = 2 to 13 do
						(
							all[frame_n][i][j] = ReadFloat F
						)
					)
				)
				fclose F
				uOpenRTM.caption = filenameFromPath fileOpenName
			)

			if rtmTM[3] != undefined do
			(
				uTM_x.value = rtmTM[1]
				uTM_y.value = - rtmTM[3]
				uTM_z.value = rtmTM[2]
			)
			if rtmFrames != undefined do
			(
				uFramesInFile.text = rtmFrames as string + " frames"
				uSelectionsInFile.text = rtmComponentCount as string + " selections"
			)

			uSelectionsList.items = componentNames
			
			local names_array = for i in $* collect i.name
			local aa = ""
			for i = 1 to rtmComponentCount do
			(
				a = findItem names_array componentNames[i]
				local j = 1
				if a == 0 do
				(
					aa = aa + componentNames[i] as string + "\n"
					j = j + 1
				)
			)
			if aa != "" then
			(
				aa = "not found in scene:\n" + aa
				messagebox aa
			) else (
				max select none
				uApplyRTM.enabled = true
			)
			
			for i = 1 to rtmKeyTimes.count do
			(
				rtmKeyTimes[i] = rtmKeyTimes[i] as string
			)
			uKeyTimesList.items = rtmKeyTimes
		)
	)
	
	on uApplyRTM pressed do
	(
		disableSceneRedraw()
		animate on
		(
			for frame_n = 1 to rtmFrames do
			(
				at time ((rtmKeyTimes[frame_n] as float) * 100)
				(
					for i = 1 to rtmComponentCount do
					(
						execute ("select $" + all[frame_n][i][1])
						selection.transform = matrix3 [all[frame_n][i][2]*M[1],all[frame_n][i][4]*M[2],all[frame_n][i][3]*M[3]] [all[frame_n][i][8]*M[4],all[frame_n][i][10]*M[5],all[frame_n][i][9]*M[6]] [all[frame_n][i][5]*M[7],all[frame_n][i][7]*M[8],all[frame_n][i][6]*M[9]] [ \ 
						all[frame_n][i][11]*M[10]+(frame_n-1)*(rtmTM[1]/rtmFrames), \ 
						all[frame_n][i][13]*M[11]-(frame_n-1)*(rtmTM[3]/rtmFrames), \ 
						all[frame_n][i][12]*M[12]+(frame_n-1)*(rtmTM[2]/rtmFrames)]
					)
				)
			)
		)
		max select none
		enableSceneRedraw()
	)

	group "About"
	(
		button aboutRTMKit "About RTM utility" width:140 height:20
	)
	local aboutRTM = "RTM utilite\nby Sandro\n\nsandro-de-parma.narod.ru\nazarubin@mail.ru\n :)\n"
	on aboutRTMKit pressed do messagebox aboutRTM title:"About rtm utility"

	on rtmUtilityImport open do
	(
		uApplyRTM.enabled = false
	)
	on rtmUtilityImport close do
	(
		uSelectionsList.items = #()
		uKeyTimesList.items = #()
	)
)
